#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# (c) 2008 by Intevation GmbH
# This is Free software under the GPLv3. 
# See LICENSE comming with the source of 'mpuls offline'
# for details.
#
# author: Sascha L. Teichmann (sascha.teichmann@intevation.de)
#

from os       import listdir, system, pardir
from os.path  import join, isfile, isdir, sep, normpath, dirname
from datetime import date

VERSION_NUMBER = '1.3.3'
VERSION_DATE   = date.today().strftime("%d.%m.%Y")
# needs for version info of installer file 
# (Format: x.x.x.x) = "VIProductVersion" in NSIS Installer
PRODUCTVERSION = "1.3.3.0"
BUILD_DIR      = "dist"

MAKENSIS_CALL = \
'makensis -DVERSION_NUMBER=%(VERSION_NUMBER)s -DVERSION_DATE=%(VERSION_DATE)s ' \
'-DPRODUCTVERSION=%(PRODUCTVERSION)s -DBUILD_DIR=%(BUILD_DIR)s %(NSI)s' % {
    'VERSION_NUMBER': VERSION_NUMBER,
    'VERSION_DATE':   VERSION_DATE,
    'PRODUCTVERSION': PRODUCTVERSION,
    'BUILD_DIR':      join(pardir, BUILD_DIR),
    'NSI':            join(dirname(__file__), 'offline-installer.nsi')
}

def traverse(path, out, base_len):

    win_path = lambda p: p[base_len:].replace('/', '\\')

    dirs = [ path ]

    while dirs:
        path = dirs.pop()

        files = []

        for f in listdir(path):
            f = join(path, f)
            if   isfile(f): files.append(f)
            elif isdir(f):  dirs. append(f)

        if files:
            print >> out, 'SetOutPath "$INSTDIR\\%s"' % win_path(path)
            for f in files:
                print >> out, 'File "${DIST_DIR}\\%s"' % win_path(f)
            print >> out

def main():
    f = None
    try:
        f = open(join(dirname(__file__), "inputfiles.nsh"), "w")
        path = normpath(BUILD_DIR)
        traverse(path, f, len(path)+len(sep))
    finally:
        if f: f.close()

    system(MAKENSIS_CALL)

if __name__ == '__main__':
    main()

# vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
