;(c)07-2008 Emanuel Schuetze, Intevation GmbH
;emanuel@intevation.de


;--------------------------------
;Include Modern UI
  !include "MUI.nsh"


;--------------------------------
;Version Information (for installer file properties)

  !define PRODUCT_NAME "mpuls WASKO Offline-Klient"
  !define PRODUCT_NAME_SHORT "WASKO-Offline"
  !define COMPANY "Intevation GmbH"
  !define COPYRIGHT "Copyright (C) 2008 Intevation GmbH"
  !define DESCRIPTION "Mit dem mpuls WASKO Offline-Klient knnen elektronische Fallakten fr die Schulverweigerung zweite Chance ausgefllt werden."

  !define OPTIONS_INI "installer-options.ini"

  !define APP_ICON "$INSTDIR\static\images\icons\app.ico"

  VIProductVersion "${PRODUCTVERSION}" ;needs format: x.x.x.x
  VIAddVersionKey "ProductName" "${PRODUCT_NAME_SHORT}"
  VIAddVersionKey "CompanyName" "${COMPANY}"
  VIAddVersionKey "LegalTrademarks" ""
  VIAddVersionKey "LegalCopyright" "${COPYRIGHT}"
  VIAddVersionKey "FileDescription" "${DESCRIPTION}"
  VIAddVersionKey "FileVersion" "${VERSION_NUMBER} (build ${VERSION_DATE})"
  VIAddVersionKey "Comments" \
   "${PRODUCT_NAME_SHORT} is Free Software; you can redistribute it  \
    and/or modify it under the terms of the GNU General Public License.  \
    You should have received a copy of the GNU General Public License  \
    along with this software; if not, write to the Free Software  \
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,  \
    MA 02110-1301, USA"


;--------------------------------
;General

  ; Define Name, File and Installdir of Installer
  Name "${PRODUCT_NAME_SHORT}"
  OutFile "${PRODUCT_NAME_SHORT}-${VERSION_NUMBER}-setup.exe"
  InstallDir "$PROGRAMFILES\${PRODUCT_NAME_SHORT}-${VERSION_NUMBER}"

  ; Get installation folder from registry if available;
  ; -> not needed because parallel installations in new INSTDIRs are allowed
  ; InstallDirRegKey HKLM "Software\${PRODUCT_NAME_SHORT}" ""

  ; Define src dir
  !define DIST_DIR "${BUILD_DIR}"

  ; Add (custom) plugin dir
  ;!addPluginDir "plugins"

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

  ; MUI Settings / Icons
  !define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\orange-install.ico"
  !define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\orange-uninstall.ico"

  ; MUI Settings / Header
  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_RIGHT
  !define MUI_HEADERIMAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Header\orange-r.bmp"
  !define MUI_HEADERIMAGE_UNBITMAP "${NSISDIR}\Contrib\Graphics\Header\orange-uninstall-r.bmp"

  ; MUI Settings / Wizard
  !define MUI_WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\orange.bmp"
  !define MUI_UNWELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\orange-uninstall.bmp"


  ; no string "Nullsoft Install System vX.XX" in installer gui
  BrandingText " "

  ; Language Selection Dialog Settings to remember the installer language
  !define MUI_LANGDLL_REGISTRY_ROOT "HKLM"
  !define MUI_LANGDLL_REGISTRY_KEY "Software\${PRODUCT_NAME_SHORT}" 
  !define MUI_LANGDLL_REGISTRY_VALUENAME "Installer Language"

  ; Custom Welcome Page
  !define ABOUT_STR "$(T_AboutS2C) \
        \r\n\r\n$_CLICK \r\n\r\n\r\n\r\n\r\n \
        $(T_AboutS2CVersionNumber) \r\n\r\n \
        $(T_AboutS2CVersionDate)"
  !define MUI_WELCOMEPAGE_TITLE "$(T_WelcomeTitle)"
  !define MUI_WELCOMEPAGE_TEXT "${ABOUT_STR}"

  ; Show Readme on Finish page
  ;!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\RUNFLYS.txt"
  ;!define MUI_FINISHPAGE_SHOWREADME_TEXT "RUNFLYS.txt anzeigen"

;--------------------------------
;Pages
  !define MUI_PAGE_CUSTOMFUNCTION_SHOW PrintNonAdminWarning
  !insertmacro MUI_PAGE_WELCOME
  #!insertmacro MUI_PAGE_LICENSE "license.txt"
  !insertmacro MUI_PAGE_DIRECTORY
  Page custom CustomPageOptions
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH

  !define MUI_PAGE_CUSTOMFUNCTION_SHOW un.PrintNonAdminWarning
  !insertmacro MUI_UNPAGE_WELCOME
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  !insertmacro MUI_UNPAGE_FINISH


;--------------------------------
;Supported Languages

  !insertmacro MUI_LANGUAGE "English"
  !insertmacro MUI_LANGUAGE "German"


;-------------------------------
;Reserve Files

  !insertmacro MUI_RESERVEFILE_LANGDLL
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "${OPTIONS_INI}"


;--------------------------------
;Install Sections

Section ""
    SetOutPath "$INSTDIR"

    ; Store installation folder
    WriteRegStr HKLM "Software\${PRODUCT_NAME_SHORT}" "" $INSTDIR

    ; Include the input files
    !include "inputfiles.nsh"

    ; Create uninstaller
    WriteUninstaller "$INSTDIR\Uninstall.exe"

    ; Create Registry keys
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME_SHORT}" "DisplayName" "${PRODUCT_NAME_SHORT} ${VERSION_NUMBER}"
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME_SHORT}" "DisplayVersionNumber" "${VERSION_NUMBER}"
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME_SHORT}" "DisplayVersionDate" "${VERSION_DATE}"
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME_SHORT}" "UninstallString" '"$INSTDIR\uninstall.exe"'
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME_SHORT}" "NoModify" 1
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME_SHORT}" "NoRepair" 1


    SetOutPath "$INSTDIR"
    # 'all users' shell folder is used (for $DESKTOP, $SMPROGRAMS, $QUICKLAUNCH,...)
    SetShellVarContext all

    # ** Start menu **
    # Delete old Start menu entries.
    RMDir /R  "$SMPROGRAMS\${PRODUCT_NAME_SHORT} ${VERSION_NUMBER}"
    # Check if the start menu entries where requested.
    !insertmacro MUI_INSTALLOPTIONS_READ $R0 "${OPTIONS_INI}" \
        "Field 2" "State"
    IntCmp $R0 0 no_start_menu
    # Create new Start menu entries
    CreateDirectory "$SMPROGRAMS\${PRODUCT_NAME_SHORT} ${VERSION_NUMBER}"
    CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME_SHORT} ${VERSION_NUMBER}\${PRODUCT_NAME_SHORT}.lnk" "$INSTDIR\offline.exe" "" "${APP_ICON}"
    CreateShortCut  "$SMPROGRAMS\${PRODUCT_NAME_SHORT} ${VERSION_NUMBER}\Deinstallieren.lnk" "$INSTDIR\Uninstall.exe" "" "${APP_ICON}"
    #"$INSTDIR\icon\fhs.ico"
    no_start_menu:

    # ** Desktop Icon **
    # Delete old Desktop link
    Delete "$DESKTOP\${PRODUCT_NAME_SHORT}.lnk"
    # Check if the desktop entries where requested.
    !insertmacro MUI_INSTALLOPTIONS_READ $R0 "${OPTIONS_INI}" \
        "Field 3" "State"
    IntCmp $R0 0 no_desktop
    # Create new Desktop link
    CreateShortCut "$DESKTOP\${PRODUCT_NAME_SHORT}.lnk" "$INSTDIR\offline.exe" "" "${APP_ICON}"
    #"$INSTDIR\icon\fhs.ico"
    no_desktop:

    # ** Quick Launch **
    # Delete old Quick Launch Bar link
    Delete "$QUICKLAUNCH\${PRODUCT_NAME_SHORT}.lnk"
    # Check if the quick launch bar entries where requested.
    !insertmacro MUI_INSTALLOPTIONS_READ $R0 "${OPTIONS_INI}" \
        "Field 4" "State"
    IntCmp $R0 0 no_quick_launch
    StrCmp $QUICKLAUNCH $TEMP no_quick_launch
    # Create new Quick Launch Bar link
    #CreateShortCut "$QUICKLAUNCH\${PRODUCT_NAME_SHORT}.lnk" "$INSTDIR\flys.bat" "" "$INSTDIR\icon\fhs.ico"
    CreateShortCut "$QUICKLAUNCH\${PRODUCT_NAME_SHORT}.lnk" "$INSTDIR\offline.exe" "" "${APP_ICON}"
    no_quick_launch:

 SectionEnd



;--------------------------------
;Install Functions

Function ".onInit"
  ; Language select dialog - not needed!
  ;!insertmacro MUI_LANGDLL_DISPLAY
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "${OPTIONS_INI}"
  call CheckExistingVersion
FunctionEnd

; Check whether application has already been installed.
Function CheckExistingVersion
  ClearErrors
  Push $0
  ReadRegStr $0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME_SHORT}" "DisplayVersionNumber"
  IfErrors leave 0
    MessageBox MB_YESNO|MB_ICONEXCLAMATION "${PRODUCT_NAME_SHORT} $0 \
    $(T_AlreadyInstalled)" IDYES leave
    Abort
  leave:
FunctionEnd

# PrintNonAdminWarning

# Check whether the current user is in the Administrator group or an
# OS version without the need for an Administrator is in use. Print a
# diagnostic if this is not the case and abort installation.
Function PrintNonAdminWarning
  ClearErrors
  UserInfo::GetName
  IfErrors leave
  Pop $0
  UserInfo::GetAccountType
  Pop $1
  StrCmp $1 "Admin" leave +1
  MessageBox MB_OK|MB_ICONEXCLAMATION "$(T_AdminNeeded)"
  Quit

 leave:
FunctionEnd

; Custom Page for add Desktop, Startmenu and Quick Launch links
Function CustomPageOptions
  !insertmacro MUI_HEADER_TEXT "$(T_InstallOptions)" "$(T_InstallOptLinks)"

  # Note that the default selection is done in the ini file.
  !insertmacro MUI_INSTALLOPTIONS_WRITE "${OPTIONS_INI}" \
        "Field 1" "Text"  "$(T_InstOptLabelA)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "${OPTIONS_INI}" \
        "Field 2" "Text"  "$(T_InstOptFieldA)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "${OPTIONS_INI}" \
        "Field 3" "Text"  "$(T_InstOptFieldB)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "${OPTIONS_INI}" \
        "Field 4" "Text"  "$(T_InstOptFieldC)"

  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "${OPTIONS_INI}"
FunctionEnd




;-----------------
; Language Strings
;-----------------
# From Function CheckExistingVersion
LangString T_AlreadyInstalled ${LANG_ENGLISH} \
    "has already been installed.$\r$\nDo you want to\
    continue the installation of ${PRODUCT_NAME_SHORT} ${VERSION_NUMBER}?"
LangString T_AlreadyInstalled ${LANG_GERMAN} \
    "ist bereits auf ihrem System installiert.$\r$\nWollen Sie die \
    Installation von ${PRODUCT_NAME_SHORT} ${VERSION_NUMBER} fortsetzen?$\r$\n$\r$\nIhre \
    alte Installation wird dadurch nicht berschrieben."

# From Custom Welcome Page
#
# Title
LangString T_WelcomeTitle ${LANG_ENGLISH} \
  "Welcome to the installation of ${PRODUCT_NAME_SHORT}"
LangString T_WelcomeTitle ${LANG_GERMAN} \
  "Willkommen bei der Installation von ${PRODUCT_NAME_SHORT}"
# description
LangString T_AboutS2C ${LANG_ENGLISH} \
    "The mpuls WASKO Offline client allows you to fill out electronical maintained cases for the Schulverweigerung zweite Chance."
LangString T_AboutS2C ${LANG_GERMAN} \
    "Mit dem mpuls WASKO-Offline-Klienten knnen elektronische Fallakten fr die Schulverweigerung zweite Chance ausgefllt werden."
# version number
LangString T_AboutS2CVersionNumber ${LANG_ENGLISH} \
    "mpuls WASKO-Offline-Klient version: ${VERSION_NUMBER}"
LangString T_AboutS2CVersionNumber ${LANG_GERMAN} \
    "mpuls WASKO-Offline-Klient Version: ${VERSION_NUMBER}"
# version number
LangString T_AboutS2CVersionDate ${LANG_ENGLISH} \
    "Release date: ${VERSION_DATE}"
LangString T_AboutS2CVersionDate ${LANG_GERMAN} \
    "Releasedatum: ${VERSION_DATE}"



# From Function CustomPageOptions
# English
LangString T_InstallOptions ${LANG_ENGLISH} "Install Options"
LangString T_InstallOptLinks ${LANG_ENGLISH} "Start links"
LangString T_InstOptLabelA  ${LANG_ENGLISH} "Please select where mpuls WASKO-Offline client shall install links:"
LangString T_InstOptFieldA  ${LANG_ENGLISH} "Start Menu"
LangString T_InstOptFieldB  ${LANG_ENGLISH} "Desktop"
LangString T_InstOptFieldC  ${LANG_ENGLISH} "Quick Launch Bar"
#German
LangString T_InstallOptions ${LANG_GERMAN} "Installationsoptionen"
LangString T_InstallOptLinks ${LANG_GERMAN} "Startlinks"
LangString T_InstOptLabelA ${LANG_GERMAN} "Bitte whlen Sie, welche Verknpfungen angelegt werden sollen:"
LangString T_InstOptFieldA ${LANG_GERMAN} "Startmen"
LangString T_InstOptFieldB ${LANG_GERMAN} "Arbeitsflche"
LangString T_InstOptFieldC ${LANG_GERMAN} "Schnellstartleiste"

# From Function (un.)PrintNonAdminWarning
LangString T_AdminNeeded ${LANG_ENGLISH} \
   "Warning: Administrator permissions required for the installation of ${PRODUCT_NAME_SHORT}."
LangString T_AdminNeeded ${LANG_GERMAN} \
   "Achtung: Fr die Installation von ${PRODUCT_NAME_SHORT} werden Administratorrechte bentigt."
LangString T_AdminNeeded_uninstall ${LANG_ENGLISH} \
   "Warning: Administrator permissions required for the uninstallation of ${PRODUCT_NAME_SHORT}."
LangString T_AdminNeeded_uninstall ${LANG_GERMAN} \
   "Achtung: Fr die Deinstallation von ${PRODUCT_NAME_SHORT} werden Administratorrechte bentigt."




;--------------------------------
;Uninstall Sections

Section "un."
  ; Kill Inteproxy process (if running)
  ;ExecDos::exec '"$SYSDIR\cmd.exe" /C "taskkill /T /F /fi "imagename eq inteproxy*""'

  ; Delete installation dir
  RMDir /R "$INSTDIR"

  # 'all users' shell folder is used (for $DESKTOP, $SMPROGRAMS, $QUICKLAUNCH,...)
  SetShellVarContext all


  ; Delete start menu entries
  RMDir /R  "$SMPROGRAMS\${PRODUCT_NAME_SHORT} ${VERSION_NUMBER}"
  ; Delete Desktop Icon
  Delete "$DESKTOP\${PRODUCT_NAME_SHORT}.lnk"
  ; Delete Quick Launch Link
  Delete "$QUICKLAUNCH\${PRODUCT_NAME_SHORT}.lnk"

  ; Delete regestry keys (if NO other FLYS installation exists)
  ReadRegStr $0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME_SHORT}" "DisplayVersionNumber"
  StrCmp $0 "${VERSION_NUMBER}" 0 +3
      DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME_SHORT}"
      DeleteRegKey /ifempty HKLM "Software\${PRODUCT_NAME_SHORT}"

SectionEnd


;--------------------------------
;Uninstall Functions

Function un.onInit
  ;!insertmacro MUI_UNGETLANGUAGE
FunctionEnd

# PrintNonAdminWarning (uninstall)
Function un.PrintNonAdminWarning
  ClearErrors
  UserInfo::GetName
  IfErrors leave
  Pop $0
  UserInfo::GetAccountType
  Pop $1
  StrCmp $1 "Admin" leave +1
  MessageBox MB_OK|MB_ICONEXCLAMATION "$(T_AdminNeeded_uninstall)"
  Quit

 leave:
FunctionEnd
