# -*- coding: latin1 -*-
#
# Copyright 2007, 2008 Intevation GmbH, Germany, <info@intevation.de>
# 
# This file is part of mpuls WASKA (CoMPUter-based case fiLeS - 
# Web-Anwendungs-Server fuer Kompetenzagenturen).
# 
# mpuls WASKA is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
# 
# mpuls WASKA is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public
# License for more details.
# 
# You should have received a copy of the GNU Affero General Public
# License along with mpuls WASKA. If not, see <http://www.gnu.org/licenses/>.
# 
# mpuls WASKA has been developed on behalf of the 
# Projekttraeger im Deutschen Zentrum fuer Luft- und Raumfahrt e.V. (PT-DLR)
# within the programme Kompetenzagenturen (Durchfuehrungsphase) funded by
# the Bundesministerium fuer Familie, Senioren, Frauen und Jugend and 
# European Social Fund resources.
#
# Authors:
# Sascha L. Teichmann <teichmann@intevation.de>
#

from parser import Factory, Creator

from offline.model.nodecomponents import Document

class SimpleCreator(Creator):

    def __init__(self, factoryClass, ncClass):
        self.factoryClass = factoryClass
        self.ncClass      = ncClass

    def createFactory(self, name, attrs, ctx):
        obj = self.ncClass()
        try:
            getattr(obj, 'setLoadContext')(ctx)
        except AttributeError:
            pass
        return self.factoryClass(attrs, obj)

class NodeComponentFactory(Factory):

    def __init__(self, attrs, nc):
        self.nc = nc
        for key in attrs.getNames():
            value = attrs.getValue(key)
            self.nc.setAttribute(key, value)

    def reduce(self, ctx):
        return self.nc

class NodeFactory(NodeComponentFactory):

    def eat(self, element, ctx):
        self.nc.addChild(element)

class DocumentFactory(NodeFactory):

    def reduce(self, ctx):
        root = NodeFactory.reduce(self, ctx)
        return Document(root)

# vim:set ts=4 sw=4 si et sta sts=4:
